///////////////////////////////////////////////////////////////////////////////
//
//  CodeJock.DockingPane
//
//  Notes:
//  This doesn't work with Xbase++ SL1
//  Other problems exist too.  Still working on this one.
//
///////////////////////////////////////////////////////////////////////////////

#INCLUDE "dcdialog.CH"
#INCLUDE "XCodeJock.CH"
#INCLUDE "DockingPane.ch"
#INCLUDE "CJbitmap.CH"

FUNCTION Main()

LOCAL GetList[0], GetOptions, oDockingPane, oStatic, oGroupThemes, bAction, ;
      nTheme, oDesktop := AppDeskTop(), aWindows[6,4], aDir, oBrowse, ;
      oButton, oStatic3

CJ_Version('13.0.0')

nTheme := ThemeDefault
aDir := Directory()

cLogoFile := "minilogo.bmp"

* Container for the panes AND (!) the bitmap:
@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 100,30 OBJECT oStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY COLOR nil, XBPSYSCLR_TRANSPARENT

* Bitmap:
@ 6,10 DCSTATIC type XBPSTATIC_TYPE_TEXT color XBPSYSCLR_TRANSPARENT,XBPSYSCLR_TRANSPARENT size 45,4 ;
       OBJECT oStatBit PARENT oStatic
       DCBITMAP {||cLogoFile} PARENT oStatBit AUTOSCALE CENTER

* DockingPanes:
@ 0,0 DCACTIVEXCONTROL oDockingPane SIZE 100,30 ;
      PARENT oStatic ;
      CLSID 'CodeJock.DockingPane' + CJ_Version() ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@  0,0 DCSAY 'This is a Yellow Window' COLOR nil, GRA_CLR_YELLOW ;
   FONT '16.Arial Bold' ;
   OBJECT aWindows[1,1] SAYWORDBREAK PARENT oStatic ;
   EVAL {|o|o:hide(),aWindows[1,2] := o:getHwnd(),aWindows[1,3]:=BITMAP_DESIGN_M,o:resize := {|a,b,o|o:invalidateRect()}}

@  0,0 DCSAY 'This is a Green Window' COLOR nil, GRA_CLR_GREEN ;
   FONT '16.Arial Bold' ;
   OBJECT aWindows[2,1] SAYWORDBREAK PARENT oStatic ;
   EVAL {|o|aWindows[2,2] := o:getHwnd(),aWindows[2,3]:=BITMAP_BUG_M}

@ 0, 102 DCGROUP oGroupThemes CAPTION 'Visual Themes' SIZE 20,16 ;
      RESIZE DCGUI_RESIZE_REPOSONLY

bAction := {||oDockingPane:visualTheme := nTheme}
DCSETPARENT TO oGroupThemes
@ 2,1 DCRADIO nTheme VALUE ThemeDefault PROMPT 'Default' ACTION bAction
@ 3,1 DCRADIO nTheme VALUE ThemeOffice PROMPT 'Office' ACTION bAction
@ 4,1 DCRADIO nTheme VALUE ThemeOffice2003 PROMPT 'Office 2003' ACTION bAction
@ 5,1 DCRADIO nTheme VALUE ThemeNativeWinXP PROMPT 'Win XP' ACTION bAction
@ 6,1 DCRADIO nTheme VALUE ThemeGrippered PROMPT 'Grippered' ACTION bAction
@ 7,1 DCRADIO nTheme VALUE ThemeVisio PROMPT 'Visio' ACTION bAction
@ 8,1 DCRADIO nTheme VALUE ThemeWhidbey PROMPT 'Whidbey' ACTION bAction
@ 9,1 DCRADIO nTheme VALUE ThemeShortcutBar2003 PROMPT 'ShortcutBar 2003' ACTION bAction
@10,1 DCRADIO nTheme VALUE ThemeExplorer PROMPT 'Explorer' ACTION bAction
@11,1 DCRADIO nTheme VALUE ThemeVisualStudio2005 PROMPT 'Visual Studio 2005' ACTION bAction
@12,1 DCRADIO nTheme VALUE ThemeOffice2007 PROMPT 'Office 2007' ACTION bAction
@13,1 DCRADIO nTheme VALUE ThemeWord2007 PROMPT 'Word 2007' ACTION bAction
@14,1 DCRADIO nTheme VALUE ThemeOutlook2007 PROMPT 'Outlook 2007' ACTION bAction

DCSETPARENT TO

DCGETOPTIONS RESIZE
DCREAD GUI FIT TITLE 'CodeJock.DockingPane Sample' OPTIONS GetOptions ;
   EVAL {|o|BuildPanes(oDockingPane,aWindows,GetList),oStatBit:ToBack()}


RETURN nil

* ------------

PROC appsys ; RETURN

* ------------

STATIC FUNCTION BuildPanes( oDockingPane, aWindows, aGetList )

LOCAL oPane, oStatic, GetList[0], GetOptions, aDir, oBrowse, nPointer

CJLoadBitMap '..\..\bitmaps\editmemo.bmp' ID BITMAP_EDITMEMO_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\design.bmp' ID BITMAP_DESIGN_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\calc.bmp' ID BITMAP_CALCULATOR_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\calendar.bmp' ID BITMAP_CALENDAR_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\bug.bmp' ID BITMAP_BUG_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\exit_m.bmp' ID BITMAP_EXIT_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\hex.bmp' ID BITMAP_HEX_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\help.bmp' ID BITMAP_HELP_M STATE xtpImageNormal PARENT oDockingPane:icons
CJLoadBitMap '..\..\bitmaps\prg.bmp' ID BITMAP_PRG_M STATE xtpImageNormal PARENT oDockingPane:icons

oDockingPane:visualTheme := ThemeVisio

oPane := oDockingPane:CreatePane( 1, 400, 400, DockLeftOf )
oPane:title := 'I am Yellow'
oPane:tabColor := CJ_Color(GRA_CLR_YELLOW)
oPane:iconId := BITMAP_DESIGN_M
oPane:setHandle( aWindows[1,2])
aWindows[1,4] := oPane

oPane := oDockingPane:CreatePane( 2, 400, 400, DockLeftOf )
oPane:title := 'I am Green'
oPane:tabColor := CJ_Color(GRA_CLR_GREEN)
oPane:iconID := BITMAP_BUG_M
oPane:setHandle( aWindows[2,2])
aWindows[2,4] := oPane

aDir := Directory()
Sleep(20)
DC_CompleteEvents()

@ 40,10 DCBROWSE oBrowse DATA aDir SIZE 300,400 FIT PIXEL ;
       PARENT aWindows[2,1] FONT '8.Helv' ;
       POINTER nPointer ;
       ITEMSELECTED {||MsgBox('You chose '+ aDir[nPointer,1])}

DCBROWSECOL ELEMENT 1 HEADER 'File' PARENT oBrowse WIDTH 10
DCBROWSECOL ELEMENT 2 HEADER 'Size' PARENT oBrowse WIDTH 10

DCREAD GUI PARENT aWindows[2,1] EXIT SAVE

RETURN nil


